#import "KinemeTexturePort.h"

@implementation KinemeTexturePort
+ (Class)baseClass
{
	return [KinemeTexturePort class];
}
- (Class)valueClass
{
	return [KinemeTexture class];
}
- (BOOL)acceptValuesOfClass:(Class)c
{
//	NSLog(@"KinemeTexturePort::acceptValuesOfClass(%@)",[c description]);
	return [c isSubclassOfClass:[KinemeTexture class]];
}
- (NSString *)tooltipString
{
	return [_texture description];
}


- (KinemeTexture *)textureValue
{
	return _texture;
}
- (id)value
{
	return [self textureValue];
}

- (void)setTextureValue:(KinemeTexture *)texture
{
//	NSLog(@"KinemeTexturePort::setTextureValue(%08x)",texture);
	[self willChangeValue];
	
	if(_texture)
		[_texture release];

	if(texture)
		_texture=[texture retain];
	else
		_texture=nil;
	
	[self didChangeValue];
}
- (BOOL)setValue:(id)v
{
	[self setTextureValue:v];
	return YES;
}

- (id)initWithNode:(QCPatch *)node arguments:(NSDictionary *)arguments;
{
	id z=[super initWithNode:node arguments:arguments];
	_texture=nil;
	return z;
}
@end
