#import <QCPatch.h>
#import <QCPort.h>

@interface QCPatch (Wrappers)
- (id)inputs;
- (id)outputs;
- (id)ivarInputs;
- (id)ivarOutputs;
- (id)customInputs;
- (id)customOutputs;
- (id)systemInputs;
- (id)systemOutputs;
- (QCPort *)createInputWithPortClass:(Class)class forKey:(NSString *)key attributes:(id)fp16;
- (QCPort *)createInputWithPortClass:(Class)class forKey:(NSString *)key attributes:(id)fp16 arguments:(id)fp20;
- (QCPort *)createOutputWithPortClass:(Class)class forKey:(NSString *)key attributes:(id)fp16;
- (QCPort *)createOutputWithPortClass:(Class)class forKey:(NSString *)key attributes:(id)fp16 arguments:(id)fp20;
- (void)deleteInputForKey:(NSString *)key;
- (void)deleteOutputForKey:(NSString *)key;
- (QCPort *)inputForKey:(NSString *)key;
- (NSString *)keyForInput:(QCPort *)port;
- (QCPort *)outputForKey:(NSString *)key;
- (NSString *)keyForOutput:(QCPort *)port;
- (id)parentPatch;
- (id)subpatches;
- (BOOL)canAddSubpatch:(id)fp8;
- (BOOL)addSubpatch:(id)fp8 forKey:(id)fp12;
- (void)removeSubpatchForKey:(id)fp8;
- (id)subpatchForKey:(id)fp8;
- (id)keyForSubpatch:(id)fp8;
- (id)pathForSubpatch:(id)fp8;
- (id)subpatchForPath:(id)fp8;
- (BOOL)canLinkOutput:(id)fp8 toInput:(id)fp12;
- (id)createLinkFromOutput:(id)fp8 toInput:(id)fp12 forKey:(id)fp16;
- (void)deleteLinkForKey:(id)fp8;
- (id)links;
- (id)linkForKey:(id)fp8;
- (id)keyForLink:(id)fp8;
- (BOOL)canPublishInput:(id)fp8;
- (BOOL)canPublishOutput:(id)fp8;
- (id)publishInput:(id)fp8 forKey:(id)fp12;
- (id)publishOutput:(id)fp8 forKey:(id)fp12;
- (void)unpublishInput:(id)fp8;
- (void)unpublishOutput:(id)fp8;
- (id)isInputPublished:(id)fp8;
- (id)isOutputPublished:(id)fp8;
- (id)pathForInput:(id)fp8;
- (id)inputForPath:(id)fp8;
- (id)pathForOutput:(id)fp8;
- (id)outputForPath:(id)fp8;
@end
