#import "TextureBlendPatch.h"

@implementation TextureBlendPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Module *ta=[[inputTextureA textureValue] texture];
	module::Module *tb=[[inputTextureB textureValue] texture];
	module::Module *tc=[[inputTextureControl textureValue] texture];

	if(ta && tb && tc)
	{
		module::Blend *blend=new module::Blend;
		blend->SetSourceModule(0,*ta);
		blend->SetSourceModule(1,*tb);
		blend->SetControlModule(*tc);

		KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:blend];
		[outputTexture setTextureValue:t];
		[t release];
	}
	else
		[outputTexture setTextureValue:nil];

	return YES;
}
@end
