#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCIndexPort.h"

#import "KinemeTexturePort.h"


// A simple base class for texture-outputting patches.
@interface TexturePatch : QCPatch
{
	KinemeTexturePort *outputTexture;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;
@end