#import "TextureRenderPatch.h"
#import "QCGLCGImage.h"

@implementation TextureRenderPatch

+ (int)executionMode
{
	return 0;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 0;
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	if(z)
	{
		currentPixelsWide = 128;
		currentPixelsHigh = 128;
		
		[inputPixelsWide setIndexValue:currentPixelsWide];
		[inputPixelsHigh setIndexValue:currentPixelsHigh];
		
		[inputPixelsWide setMaxIndexValue:4096];
		[inputPixelsHigh setMaxIndexValue:4096];


		[inputType setMaxIndexValue:2];
	}

	return z;
}


- (id)setup:(QCOpenGLContext *)context
{
	_renderer = [[KinemeTextureRenderer alloc] initWithPixelsWide:currentPixelsWide
		pixelsHigh:currentPixelsHigh];

	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
//	NSLog(@"TextureRenderPatch::execute()");

	BOOL realloc = FALSE;

	if( currentPixelsWide != [inputPixelsWide indexValue] )
	{
		currentPixelsWide = [inputPixelsWide indexValue];
		
		if(currentPixelsWide < 16)
		{
			currentPixelsWide = 16;
			[inputPixelsWide setIndexValue: 16];
		}
		
		realloc = TRUE;
	}
	if( currentPixelsHigh != [inputPixelsHigh indexValue] )
	{
		currentPixelsHigh  = [inputPixelsHigh indexValue];
		
		if(currentPixelsHigh < 16)
		{
			currentPixelsHigh = 16;
			[inputPixelsHigh setIndexValue: 16];
		}
		realloc = TRUE;
	};

	if( realloc )
	{
		[_renderer release];
		
		_renderer = [[KinemeTextureRenderer alloc] initWithPixelsWide:currentPixelsWide
			pixelsHigh:currentPixelsHigh];
	}


	module::Module *z=[[inputTexture textureValue] texture];

	if(z)
	{
		QCGLCGImage *qcglOut =
			[_renderer
				QCGLCGImageWithModule:z
				type:[inputType indexValue]
			];
		[outputImage setImageValue:qcglOut];
		[qcglOut release];
	}
	else
		[outputImage setImageValue:nil];

	return YES;
}

@end
