#import "TextureSelectPatch.h"

@implementation TextureSelectPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputBoundLower setDoubleValue:-1.0];
	[inputBoundUpper setDoubleValue:1.0];
	[inputFalloff setDoubleValue:0.0];

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Module *ta=[[inputTextureA textureValue] texture];
	module::Module *tb=[[inputTextureB textureValue] texture];
	module::Module *tc=[[inputTextureControl textureValue] texture];

	if(ta && tb && tc)
	{
		module::Select *select=new module::Select;
		select->SetSourceModule(0,*ta);
		select->SetSourceModule(1,*tb);
		select->SetControlModule(*tc);
		select->SetBounds([inputBoundLower doubleValue],[inputBoundUpper doubleValue]);
		select->SetEdgeFalloff([inputFalloff doubleValue]);

		KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:select];
		[outputTexture setTextureValue:t];
		[t release];
	}
	else
		[outputTexture setTextureValue:nil];

	return YES;
}
@end
