#import "TextureTurbulencePatch.h"

@implementation TextureTurbulencePatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputSeed setIndexValue:0];
	[inputFrequency setDoubleValue:1.0];
	[inputPower setDoubleValue:1.0];
	[inputRoughness setIndexValue:3];

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Module *z=[[inputTexture textureValue] texture];

	if(z)
	{
		module::Turbulence *turbulence=new module::Turbulence;
		turbulence->SetSourceModule(0,*z);
		turbulence->SetSeed([inputSeed indexValue]);
		turbulence->SetFrequency([inputFrequency doubleValue]);
		turbulence->SetPower([inputPower doubleValue]);
		turbulence->SetRoughness([inputRoughness indexValue]);

		KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:turbulence];
		[outputTexture setTextureValue:t];
		[t release];
	}
	else
		[outputTexture setTextureValue:nil];

	return YES;
}
@end
